#!/bin/bash

#Given a file, this function runs the jq command and saves it back
replace_value() {
	file_name=$1
	jq_command=$2
	cat $file_name|jq $jq_command > tmpfile && mv tmpfile $file_name
}

#For the moment, this just calls echo. Can be enhanced later
log(){
	echo "LOG [$1]"
}

log "load the environment variables"
. /resources/.artifactory_env || exit 1

php_app_destination="/var/www/html/cloudbox"
vendor_files="vendor/jfrog/insight-core"

mkdir -p $php_app_destination

log "determining the context url"
ARTIFACTORY_CONTEXTURL_WITH_TOKEN=$(echo $artifactory_contextUrl | sed -e "s~\([^://]\)://\(.*\)~\1://${artifactory_user}:${artifactory_token}@\2~g") || exit 1

echo '{"name":"na/builder","type":"project","authors":[],"require":{"jfrog/insight-core":"'${CORE_VERSION}'"},"config":{"secure-http":false,"preferred-install":{"*":"dist"},"http-basic":{"'${artifactory_server}'":{"username":"'${artifactory_user}'","password":"'${artifactory_token}'"}}},"repositories":[{"type":"composer","url":"'${ARTIFACTORY_CONTEXTURL_WITH_TOKEN}'/api/composer/'${PHP_REPO}'"},{"packagist":false}]}' > $php_app_destination/composer.json || exit 1

log "Composer being used: "
cat $php_app_destination/composer.json

log "Installing dependencies"
cd $php_app_destination && composer install || exit 1

log "copying php files"
cp $php_app_destination/$vendor_files/run.php $php_app_destination/$vendor_files/core.phar $php_app_destination && \

log "set versions"
replace_value $php_app_destination/$vendor_files/config/master/contexts/settings/cloudmunch  ".|del(.version.ui)"
replace_value $php_app_destination/$vendor_files/config/master/contexts/settings/cloudmunch  ".version.platform=\"$BUILD_NUM\""

log "cleanup"
apt-get -y clean
apt-get -y autoremove
composer clearcache
